# 'modulepythong.py' debe utilizarse como mdulo en los programas 
# desarrollados en el entorno PythonG, para que puedan
# ejecutarse fuera de dicho entorno. Basta aadir al cdigo
# la lnea:
#   from modulepythong import *
# Notas:
# 1. Al finalizar la ejecucin del programa hay que cerrar
#    la ventana grfica.
# 2. La salida de error est en el terminal desde el que se
#    lanza el programa.
#
# Copyright (C) 2002 Universitat Jaume I (Castello, Spain)
#
# LICENCIA:
# Este programa es Software Libre; usted puede redistribuirlo
# y/o modificarlo bajo los trminos de la "GNU General Public
# License" como lo publica la "FSF Free Software Foundation",
# o (a su eleccin) de cualquier versin posterior.
#
# Este programa es distribuido con la esperanza de que le ser
# til, pero SIN NINGUNA GARANTIA; incluso sin la garanta
# implcita por el MERCADEO o EJERCICIO DE ALGUN PROPOSITO en
# particular. Vea la "GNU General Public License" para ms
# detalles.
#
# Usted debe haber recibido una copia de la "GNU General Public
# License" junto con este programa, si no, escriba a la "FSF
# Free Software Foundation, Inc.", 59 Temple Place - Suite 330,
# Boston, MA  02111-1307, USA.
#
#----------------------------------------------------------------
#
# AUTOR: David Llorens (dllorens@lsi.uji.es)
#        Dpto. de Lenguajes y Sistemas Informticos
#        Universitat Jaume I
#        Castell (Spain)
# LICENCIA: GPL versin 2
# FECHA: 5-Diciembre-2002
#
# CHANGELOG:
#  5-12-02 Versin 0.4 (alfa) [PythonG 2.0u]
#   -Corrige bug: keypressed(2) sin ventana de texto.
#   -window_size() y windows_coordinates() sin parametros
#    devuelven los valores actuales de los mismos.
#   -Nueva func. predef.: clear_output(). Limpia la
#    ventana de texto.
#   -Nueva func. predef.: close_window(). Se cierra todo
#    y termina el programa.
# 19-11-02 Versin 0.3 (alfa)
#   -Corrige bug: faltaba echo en raw_input().
# 14-11-02 Versin 0.2a (alfa)
#   -Cambia tamao de fuente a 13 puntos en linux.
# 31-10-02 Versin 0.2 (alfa)
#   -Versin derivada de 'pythong.py' 2.0h.
# ? Versin inicial 0.1 (alfa)
#   -Versin derivada de 'pythong.py' 2.0g.
#
#----------------------------------------------------------------
#

VERSION="0.4"

if __name__ == "__main__":
  raise "'modulepythong.py' slo puede utilizarse como mdulo."

from Tkinter import *
from os import pipe,fdopen
from string import split,join
import sys,threading,time

coordenadaserroneas="Coordenadas de la lnea erroneas"
puntoError="Algn parmetro errneo en create_point"
lineaError="Algn parmetro errneo en create_line"
textoError="Algn parmetro errneo en create_text"
circuloRellenoError="Algn parmetro errneo en create_filled_circle"
rectanguloError="Algn parmetro errneo en create_rectangle"
rectanguloRellenoError="Algn parmetro errneo en create_filled_rectangle"
indiceBorradoError="El indice del objeto que se quiere borrar es erroneo"
moveError="Algn parmetro errneo en move"
abortadoPorUsuario="Abortado por el usuario" 
nombrecolorerroneo="nombre de color erroneo" 

lineaTeclado=''
entradaFormal=0
anchoOrig = altoOrig = 400
tamMundoOrig=1001
posAncla={'CENTER':CENTER,'N':N,'S':S,'E':E,'W':W,
          'NE':NE,'SE':SE,'NW':NW,'SW':SW}
linux=sys.platform[:3]=='lin'

class Input:
  def __init__(self,pipa_salida):
    self.ps=pipa_salida
  def read(self,size):
    global entradaFormal
    entradaFormal = 1
    x = self.ps.read(size)
    entradaFormal = 0
    return x
  def readline(self):
    global entradaFormal
    if entradaFormal==1:
      x = self.ps.readline()
    else:
      entradaFormal = 1
      x = self.ps.readline()
      entradaFormal = 0
    return x
  def readlines(self):
    global entradaFormal
    old = entradaFormal 
    entradaFormal = 1
    res=[]
    lin=self.readline()
    while lin!='':
      res.append(lin)
      lin=self.readline()
    entradaFormal = old
    return res

class Output:
  def __init__(self): pass
  def write(self,string):
    if len(string)<=0: return
    ventana.mutex.acquire()
    try:
      ventana.progS.configure(state=NORMAL)
      ventana.progS.insert(END,string)
      ventana.progS.mark_set(INSERT,END)
      ventana.progS.see(INSERT)
      #ventana.progS.configure(state=DISABLED)
    except: pass
    ventana.mutex.release()
  def writelines(self,lines):
    for line in lines: self.write(line)

class MyThread(threading.Thread):
  def run(self): 
    global ventana
    ventana.raiz.mainloop()

class Ventana:
  def __init__(self, tamMundo=tamMundoOrig):
    global ventana,tFuente,conf,reading
    reading=0
    global clear_output,window_size,window_coordinates,create_text,create_line
    global create_filled_rectangle,create_rectangle,create_filled_circle
    global create_circle,create_point,erase,move,keypressed,newWorkSpace
    global close_window
    ventana=self
    newWorkSpace=self.newWorkSpace
    window_size=self.window_size
    window_coordinates=self.window_coordinates
    create_text=self.create_text
    create_line=self.create_line
    create_filled_rectangle=self.create_filled_rectangle
    create_rectangle=self.create_rectangle
    create_filled_circle=self.create_filled_circle
    create_circle=self.create_circle
    create_point=self.create_point
    clear_output=self.clear_output
    erase=self.erase
    move=self.move
    keypressed=self.keypressed
    close_window=self.salir

    self.ancho, self.alto = anchoOrig,altoOrig
    self.xinf,self.yinf,self.xsup,self.ysup = 0,0,tamMundo,tamMundo
    self.bufTeclado=[]
    self.teclaApretada=0
    self.ultimaTecla=None
 
    self.raiz = Tk()
    self.raiz.protocol("WM_DELETE_WINDOW", self.salir)
    self.raiz.title('PythonG %s (modulepythong.py) - Universitat Jaume I de Castell' % VERSION)
    
    izq=self.izq=Frame(self.raiz,borderwidth=2)
    self.lab1=Label(izq,text='Salida grfica:',anchor=W)
    self.lab1.pack(side=TOP,fill=X)
    self.workspace = Frame(izq,borderwidth=1,relief=SOLID)
    self.canvas=Canvas(self.workspace)
    self.canvas.configure(width=self.ancho, height=self.alto,
                          highlightthickness=0, bg='white',borderwidth=0,
                          relief=FLAT)
    self.canvas.pack(side=TOP,expand=NO)
    self.workspace.pack(side=TOP,expand=NO)
    izq.pack(side=LEFT)
    if linux: tFuente=('lucidatypewritter',13,'bold')
    else:     tFuente=('courier',12,'bold')
    
    der=self.der=Frame(self.raiz,borderwidth=2)
    Label(der,text='Entrada de teclado/Salida de texto:',anchor=W).pack(side=TOP,fill=X)
    fuente = Frame(der,borderwidth=0,relief=FLAT)
    
    self.progS = Text(fuente,borderwidth=0,relief=FLAT)
    self.scrollS = Scrollbar(fuente,command=self.progS.yview,relief=FLAT,
                             highlightthickness=0, takefocus='no')
    self.scrollSx = Scrollbar(der,command=self.progS.xview,
                              relief=FLAT,highlightthickness=0,
                              takefocus='no',orient=HORIZONTAL)
    self.progS.configure(yscrollcommand=self.scrollS.set,
                         xscrollcommand=self.scrollSx.set,
                         font=tFuente,height=1,width=45,
                         foreground='white', background='black',
                         insertbackground='red',insertwidth=3,
                         insertofftime=200, insertontime=500,
                         state=DISABLED,wrap=NONE)
    self.progS.configure(state=NORMAL)
    self.progS.focus_set()
    self.progS.pack(side=LEFT,fill=BOTH,expand=YES)
    self.scrollS.pack(side=RIGHT,fill=Y)
    fuente.pack(side=TOP,fill=BOTH,expand=YES)
    self.scrollSx.pack(side=TOP,fill=X)
    der.pack(side=RIGHT,fill=BOTH,expand=YES)
    self.teclaApretada=0
    self.bufB=[]
    self.mutex = threading.Lock()
    self.mutex.acquire()
    self.raiz.update()
    (self.r,self.w)=pipe()
    self.inp=fdopen(self.w,"w",0)
    self.out=fdopen(self.r,"r",0)
    sys.stdin=Input(self.out)
    sys.stdout=Output()
    #sys.stderr=Output()
    #ventana.raiz.bind('<KeyPress>', ventana.eventoTeclaPulsada)
    #ventana.raiz.bind('<KeyRelease>', ventana.eventoTeclaSoltada)
    ventana.raiz.bind('<Control-c>', ventana.salir)
    ventana.raiz.bind('<Control-C>', ventana.salir)
    self.ancho, self.alto = anchoOrig, altoOrig
    self.escala_x = (self.ancho-1) / float(self.xsup-self.xinf)
    self.escala_y = (self.alto-1)  / float(self.ysup-self.yinf)
    self.progS.bind('<KeyPress>',self.eventoTeclaPulsada)
    self.progS.bind('<KeyRelease>', self.eventoTeclaSoltada)
    self.progS.bind('<ButtonPress>',self.NoHacerNada)
    self.progS.bind('<ButtonRelease>',self.NoHacerNada)
    self.progS.bind('<Motion>',self.NoHacerNada)
    self.miUpdate()

  def NoHacerNada(self,event=None):
    return "break"

  def salir(self,event=None):
    from os import name
    if name=='posix':
      from os import getpid,kill
      import signal
      kill(getpid(),signal.SIGKILL)
    else:
      self.raiz.quit()

  def miUpdate(self):
    self.mutex.release()
    time.sleep(0.05)
    self.mutex.acquire()
    self.raiz.update() #si se quita se acelera la ejecucin 
                       #falta comprobar efector secundarios
    self.raiz.after(1, self.miUpdate)

  def eventoTeclaPulsada(self, event):
    global lineaTeclado, entradaFormal
    if event.char=='\x03': return #Control-c
    if entradaFormal==1:
      if event.keysym=='Return':
        self.progS.insert(END,'\n')
        self.inp.write(lineaTeclado+'\n')
        lineaTeclado=''
      elif event.keysym=='BackSpace':
        if len(lineaTeclado)>0:
            lineaTeclado =lineaTeclado[:-1]
            self.progS.delete(END+'-2c',END)
      else:
        lineaTeclado=lineaTeclado+event.char
        self.progS.insert(END,event.char)
      self.teclaApretada=1
      return "break"
    else:
      self.ultimaTecla=event.keysym
      self.bufTeclado=[event.keysym]
      #self.bufTeclado.append(event.keysym)
      #if len(self.bufTeclado)>20: self.bufTeclado=self.bufTeclado[-10:]
      self.teclaApretada=1
      return "break"

  def eventoTeclaSoltada(self, event):
    self.teclaApretada=0

# -------------------------------------------------
  def clear_output(self):
    self.progS.delete('1.0',END)
# -------------------------------------------------
  def newWorkSpace(self):
    self.mutex.acquire() #--------
    for i in self.workspace.children.values(): i.destroy()
    self.raiz.update()
    self.mutex.release() #--------
    return self.workspace
# -------------------------------------------------
  def window_size(self,ancho=None,alto=None):
    if ancho==None or alto==None: return [self.ancho,self.alto]
    self.ancho, self.alto = ancho, alto
    self.escala_x = (self.ancho-1) / float(self.xsup-self.xinf)
    self.escala_y = (self.alto-1)  / float(self.ysup-self.yinf)

    self.mutex.acquire() #--------
    try:
      map(self.canvas.delete,self.canvas.find_all())
      self.canvas.configure(width=self.ancho,height=self.alto)
    except TclError: pass
    self.raiz.update()
    self.mutex.release() #--------
    
  # -------------------------------------------------  
  def window_coordinates(self,xinf=None,yinf=None,
                         xsup=None,ysup=None):
    if xinf==None or yinf==None or xsup==None or ysup==None:
      return [self.xinf,self.yinf,self.xsup,self.ysup]
    self.xinf,self.yinf,self.xsup,self.ysup = xinf,yinf,xsup,ysup
    self.escala_x = (self.ancho-1) / float(self.xsup-self.xinf)
    self.escala_y = (self.alto-1)  / float(self.ysup-self.yinf)

    self.mutex.acquire() #--------
    try:   map(self.canvas.delete,self.canvas.find_all())
    except TclError: pass
    self.raiz.update()
    self.mutex.release() #--------

  # -------------------------------------------------
  def create_text(self,x,y,cadena,tam=10,ancla='CENTER',**args):
    args['text']=cadena
    args['anchor']=posAncla[ancla]
    if linux: args['font']=('lucidatypewritter',tam)
    else:     args['font']=('courier',tam)
    try:
      xb = (x-self.xinf) * self.escala_x 
      yb = self.alto - 1 - (y- self.yinf) * self.escala_y
    except:
      raise coordenadaserroneas, (x,y)
    self.mutex.acquire() #--------
    try:
      aux = self.canvas.create_text(xb, yb, args)
    except:
      self.mutex.release() #--------
      raise textoError, (x,y,cadena,ancla)
    self.mutex.release() #--------
    return aux
    
  # -------------------------------------------------
  def move(self,tags,x,y):
    try:
      xb = x*self.escala_x 
      yb = -y*self.escala_y
    except:
      raise coordenadaserroneas, (x,y)
    self.mutex.acquire() #--------
    try: self.canvas.move(tags,xb,yb)
    except:
      self.mutex.release() #--------
      raise moveError, (tags,x,y)
    self.mutex.release() #--------

  # -------------------------------------------------  
  def create_line(self,x1,y1,x2,y2,color='black',**args):
    args['fill']=color
    try:
      x1b = (x1-self.xinf) * self.escala_x 
      y1b = self.alto - 1 - (y1- self.yinf) * self.escala_y
      x2b = (x2-self.xinf) * self.escala_x
      y2b = self.alto - 1 - (y2-self.yinf) * self.escala_y
    except:
      raise coordenadaserroneas, (x1,y1,x2,y2)
    self.mutex.acquire() #--------
    try:
      aux = self.canvas.create_line(x1b, y1b, x2b, y2b, args)
    except:
      self.mutex.release() #--------
      raise lineaError, (x1,y1,x2,y2,color)
    self.mutex.release() #--------
    return aux

  def create_filled_rectangle(self,x1,y1,x2,y2,color='black',relleno=None,**args):
    if relleno==None: relleno=color
    return self.create_rectangle(x1,y1,x2,y2,color,relleno,**args);

  def create_rectangle(self,x1,y1,x2,y2,color='black',relleno=None,**args):
    args['outline']=color
    if relleno!=None: args['fill']=relleno
    try:
      x1b = (x1-self.xinf) * self.escala_x 
      y1b = self.alto - 1 - (y1- self.yinf) * self.escala_y
      x2b = (x2-self.xinf) * self.escala_x
      y2b = self.alto - 1 - (y2-self.yinf) * self.escala_y
    except:
      raise coordenadaserroneas, (x1,y1,x2,y2)
    self.mutex.acquire() #--------
    try:
      aux = self.canvas.create_rectangle(x1b, y1b, x2b, y2b, args)
    except:
      self.mutex.release() #--------
      if relleno!=None:
        raise rectanguloRellenoError, (x1,y1,x2,y2,color,relleno)
      else:
        raise rectanguloError, (x1,y1,x2,y2,color)
    self.mutex.release() #--------
    return aux

  def create_filled_circle(self,x,y,radio,color='black',relleno=None,**args):
    if relleno==None: relleno=color
    return self.create_circle(x,y,radio,color,relleno,**args);

  def create_circle(self,x,y,radio,color='black',relleno=None,**args):
    args['outline']=color
    if relleno!=None: args['fill']=relleno
    try:
      x1b=(x-self.xinf-radio)* self.escala_x
      x2b=(x-self.xinf+radio)* self.escala_x
      y1b=self.alto - 1 - (y-self.yinf-radio)* self.escala_y
      y2b=self.alto - 1 - (y-self.yinf+radio)* self.escala_y
    except:
      raise coordenadaserroneas, (x,y)
    self.mutex.acquire() #--------
    try:
      aux = self.canvas.create_oval(x1b, y1b, x2b, y2b, args)
    except:
      self.mutex.release() #--------
      if relleno!='no':
        raise circuloRellenoError, (x,y,radio,color,relleno)
      else:
        raise circuloError, (x,y,radio,color)
    self.mutex.release() #--------
    return aux

  def create_point(self,x,y,color='black',**args):
    args['fill']=color
    args['width']=2
    try:
      if linux:
        x1b=(x-self.xinf)*self.escala_x - 0.5
        x2b=x1b+2
      else:
        x1b=x2b=int((x-self.xinf)*self.escala_x - 0.5)
      y1b=self.alto - 1 - (y-self.yinf)*self.escala_y
    except:
      raise coordenadaserroneas, (x,y)
    self.mutex.acquire() #--------
    try:
      aux = self.canvas.create_line(x1b, y1b, x2b, y1b,args)
    except:
      self.mutex.release() #--------
      raise puntoError, (x,y,color)
    self.mutex.release() #--------
    return aux

  def erase(self,indice=None):
    self.mutex.acquire() #--------
    if indice==None:
      try: map(self.canvas.delete,self.canvas.find_all())
      except TclError: pass
    else:
      try:
        self.canvas.delete(indice)
      except:
        self.mutex.release() #--------
        raise indiceBorradoError, indice
    self.mutex.release() #--------


  def keypressed(self,retardo=2):
    # 0: No espera, con retardo de repeticion
    # 1: No espera, sin retardo de repeticion (juegos)
    # 2: Espera a que se pulse una tecla, si ya estaba pulsada,
    #    espera a que se suelte antes de leer la correcta.
    if retardo==2:
      while len(self.bufTeclado)==0: pass
    try:
      x = self.bufTeclado[0]
      self.bufTeclado =  self.bufTeclado[1:]
      return x
    except:
      if self.teclaApretada==1:
        if retardo==0: return None
        return self.ultimaTecla
      return None

  # -------------------------------------------------

def window_style(tit,colorFondo='white',soloGraf='TODO'):
  ventana.raiz.title(tit)
  ventana.canvas.configure(background=colorFondo)
  if soloGraf=='G': ventana.der.pack_forget()
  
Ventana()

tPython = MyThread()
tPython.start()
